module CommunityTheatre
  class Projector
    def initialize(spooler, path_base)
      @spooler = spooler
      @path_base = path_base
    end

    def projector_dir_path(*args)
      File.join(@path_base, *args)
    end

    def setup; end

    def teardown; end

    def process(item); end

    def project!(starting_at = 0)
      setup

      @spooler.unspool(starting_at).each(&method(:process))

      teardown
    end
  end
end
